'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _style = require('./style');

var _style2 = _interopRequireDefault(_style);

var _config = require('../../config');

var _Row = require('../Row');

var _ScreenClassResolver = require('../../context/ScreenClassResolver');

var _ScreenClassResolver2 = _interopRequireDefault(_ScreenClassResolver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Col = function (_React$PureComponent) {
  _inherits(Col, _React$PureComponent);

  function Col(props) {
    _classCallCheck(this, Col);

    var _this = _possibleConstructorReturn(this, (Col.__proto__ || Object.getPrototypeOf(Col)).call(this, props));

    _initialiseProps.call(_this);

    var component = props.component;

    var _getConfiguration = (0, _config.getConfiguration)(),
        componentDecorator = _getConfiguration.componentDecorator;

    _this.decoratedComponent = componentDecorator(component, _this);
    return _this;
  }

  return Col;
}(_react2.default.PureComponent);

Col.displayName = 'Col';
Col.propTypes = {
  /**
   * Content of the column
   */
  children: _propTypes2.default.node,
  /**
   * The width of the column for screenclass `xs`, either a number between 0 and 12, or "content"
   */
  xs: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.oneOf(['content'])]),
  /**
   * The width of the column for screenclass `sm`, either a number between 0 and 12, or "content"
   */
  sm: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.oneOf(['content'])]),
  /**
   * The width of the column for screenclass `md`, either a number between 0 and 12, or "content"
   */
  md: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.oneOf(['content'])]),
  /**
   * The width of the column for screenclass `lg`, either a number between 0 and 12, or "content"
   */
  lg: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.oneOf(['content'])]),
  /**
   * The width of the column for screenclass `xl`, either a number between 0 and 12, or "content"
   */
  xl: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.oneOf(['content'])]),
  /**
   * The offset of this column for all screenclasses
   */
  offset: _propTypes2.default.shape({
    xs: _propTypes2.default.number,
    sm: _propTypes2.default.number,
    md: _propTypes2.default.number,
    lg: _propTypes2.default.number,
    xl: _propTypes2.default.number
  }),
  /**
   * The amount this column is pushed to the right for all screenclasses
   */
  push: _propTypes2.default.shape({
    xs: _propTypes2.default.number,
    sm: _propTypes2.default.number,
    md: _propTypes2.default.number,
    lg: _propTypes2.default.number,
    xl: _propTypes2.default.number
  }),
  /**
   * The amount this column is pulled to the left for all screenclasses
   */
  pull: _propTypes2.default.shape({
    xs: _propTypes2.default.number,
    sm: _propTypes2.default.number,
    md: _propTypes2.default.number,
    lg: _propTypes2.default.number,
    xl: _propTypes2.default.number
  }),
  /**
   * Optional styling
   */
  style: _propTypes2.default.objectOf(_propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string])),
  /**
   * Set to apply some debug styling
   */
  debug: _propTypes2.default.bool,
  /**
   * Use your own component
   */
  component: _propTypes2.default.elementType
};
Col.defaultProps = {
  children: null,
  xs: null,
  sm: null,
  md: null,
  lg: null,
  xl: null,
  offset: {},
  push: {},
  pull: {},
  style: {},
  debug: false,
  component: 'div'
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.renderCol = function (gutterWidth, screenClass) {
    var _props = _this2.props,
        children = _props.children,
        xs = _props.xs,
        sm = _props.sm,
        md = _props.md,
        lg = _props.lg,
        xl = _props.xl,
        offset = _props.offset,
        pull = _props.pull,
        push = _props.push,
        debug = _props.debug,
        style = _props.style,
        component = _props.component,
        otherProps = _objectWithoutProperties(_props, ['children', 'xs', 'sm', 'md', 'lg', 'xl', 'offset', 'pull', 'push', 'debug', 'style', 'component']);

    var theStyle = (0, _style2.default)({
      width: {
        xs: xs,
        sm: sm,
        md: md,
        lg: lg,
        xl: xl
      },
      offset: offset,
      pull: pull,
      push: push,
      debug: debug,
      screenClass: screenClass,
      gutterWidth: gutterWidth,
      gridColumns: (0, _config.getConfiguration)().gridColumns,
      moreStyle: style
    });

    return (0, _react.createElement)(_this2.decoratedComponent, _extends({ style: theStyle }, otherProps, { children: children }));
  };

  this.render = function () {
    return _react2.default.createElement(
      _ScreenClassResolver2.default,
      null,
      function (screenClass) {
        return _react2.default.createElement(
          _Row.GutterWidthContext.Consumer,
          null,
          function (gutterWidth) {
            return _this2.renderCol(gutterWidth, screenClass);
          }
        );
      }
    );
  };
};

exports.default = Col;